#include<bits/stdc++.h>
//#include<bits/extc++.h>
//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
//using oset = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;


/*
struct segtree{
    vector<ll> tree;
    ll sz;
    ll def = 0;
    ll merg(ll a, ll b) {
        return a + b;
    }
    void clar(ll n) {
        tree.assign(4 * n, def);
        sz = n;
    }
    segtree() {

    }
    void build(ll v, ll l, ll r, vector<ll> & a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(v * 2 + 1, l, m, a);
        build(v * 2 + 2, m, r, a);
        tree[v] = merg(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
    segtree(vector<ll> & a) {
        ll n = (ll)a.size();
        clar(n);
        build(0, 0, sz, a);
    }
};
*/

void solve() {
    ll t;
    cin >> t;
    ll n, m;
    cin >> n >> m;
    vector<ll> cnt(2);
    for (ll i = 0; i < n; i++) {
        ll a;
        cin >> a;
        cnt[a % 2]++;
    }
    if (cnt[0] * cnt[1] == 0) {
        cout << "Yes" << endl;
        if (t >= 2) {
            cout << (m + 1) / 2 << endl;
        }
        if (t >= 3) {
            cout << 1 << endl;
            cout << m / 2 << " " << (m + 1) / 2 << endl;
        }
    } else {
        cout << "No" << endl;
    }
}

signed main() {
    int MULTITEST = 0;
    #ifdef zapvm
        MULTITEST = 1;
        freopen("in.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    if (MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}